<?php

namespace Bellarmine\Faculty\Http\Controllers;

use App\Http\Controllers\PublicController as CMSPublicController;
use Bellarmine\Faculty\Interfaces\FACULTYRepositoryInterface;

class FACULTYPublicController extends CMSPublicController
{
    /**
     * Constructor.
     *
     * @param type \Bellarmine\FACULTY\Interfaces\FACULTYRepositoryInterface $f_a_c_u_l_t_y
     *
     * @return type
     */
    public function __construct(FACULTYRepositoryInterface $f_a_c_u_l_t_y)
    {
        $this->model = $f_a_c_u_l_t_y;
        parent::__construct();
    }

    /**
     * Show f_a_c_u_l_t_y's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $f_a_c_u_l_t_i_e_s = $this->model->all();

        return $this->theme->of('faculty::public.f_a_c_u_l_t_y.index', compact('f_a_c_u_l_t_i_e_s'))->render();
    }

    /**
     * Show f_a_c_u_l_t_y.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $f_a_c_u_l_t_y = $this->model->findBySlug($slug);

        return $this->theme->of('faculty::public.f_a_c_u_l_t_y.show', compact('f_a_c_u_l_t_y'))->render();
    }
}
