<?php

namespace Bellarmine\Faculty\Http\Controllers;

use App\Http\Controllers\UserController as UserController;
use Former;
use Bellarmine\Faculty\Http\Requests\FACULTYUserRequest;
use Bellarmine\Faculty\Interfaces\FACULTYRepositoryInterface;
use Response;
use User;

class FACULTYUserController extends UserController
{
    /**
     * Initialize f_a_c_u_l_t_y controller.
     *
     * @param type FACULTYRepositoryInterface $f_a_c_u_l_t_y
     *
     * @return type
     */
    public function __construct(FACULTYRepositoryInterface $f_a_c_u_l_t_y)
    {
        $this->model = $f_a_c_u_l_t_y;
        $this->model->setUserFilter();
        parent::__construct();
    }

    /**
     * Display a listing of the resource.
     *
     * @return Response
     */
    public function index(FACULTYUserRequest $request)
    {
        $f_a_c_u_l_t_i_e_s = $this->model->all();

        $this->theme->prependTitle(trans('faculty::f_a_c_u_l_t_y.names').' :: ');

        return $this->theme->of('faculty::user.f_a_c_u_l_t_y.index', compact('f_a_c_u_l_t_i_e_s'))->render();
    }

    /**
     * Display the specified resource.
     *
     * @param Request $request
     * @param int     $id
     *
     * @return Response
     */
    public function show(FACULTYUserRequest $request, $role, $id)
    {
        $f_a_c_u_l_t_y = $this->model->find($id);

        return $this->theme->of('faculty::user.f_a_c_u_l_t_y.show', compact('f_a_c_u_l_t_y'))->render();
    }

    /**
     * Show the form for creating a new resource.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function create(FACULTYUserRequest $request)
    {
        $f_a_c_u_l_t_y = $this->model->findOrNew(0);

        Former::populate($f_a_c_u_l_t_y);

        return $this->theme->of('faculty::user.f_a_c_u_l_t_y.create', compact('f_a_c_u_l_t_y'))->render();
    }

    /**
     * Display the specified resource.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function store(FACULTYUserRequest $request)
    {
        try {
            $attributes = $request->all();
            $f_a_c_u_l_t_y = $this->model->create($attributes);

            return $this->success(trans('messages.success.created', ['Module' => trans('faculty::f_a_c_u_l_t_y.name')]));
        } catch (Exception $e) {
            return $this->error($e->getMessage());
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Request $request
     * @param int     $id
     *
     * @return Response
     */
    public function edit(FACULTYUserRequest $request, $role, $id)
    {
        $f_a_c_u_l_t_y = $this->model->find($id);

        Former::populate($f_a_c_u_l_t_y);

        return $this->theme->of('faculty::user.f_a_c_u_l_t_y.edit', compact('f_a_c_u_l_t_y'))->render();
    }

    /**
     * Update the specified resource.
     *
     * @param Request $request
     * @param int     $id
     *
     * @return Response
     */
    public function update(FACULTYUserRequest $request, $role, $id)
    {
        try {
            $attributes = $request->all();
            $f_a_c_u_l_t_y = $this->model->update($attributes, $id);

            return $this->success(trans('messages.success.updated', ['Module' => trans('faculty::f_a_c_u_l_t_y.name')]));
        } catch (Exception $e) {
            return $this->error($e->getMessage());
        }
    }

    /**
     * Remove the specified resource.
     *
     * @param int $id
     *
     * @return Response
     */
    public function destroy(FACULTYUserRequest $request, $role, $id)
    {
        try {
            $this->model->delete($id);

            return $this->success(trans('message.success.deleted', ['Module' => trans('faculty::f_a_c_u_l_t_y.name')]), 200);
        } catch (Exception $e) {
            return $this->error($e->getMessage());
        }
    }
}
